%% --------------------------------------------------------------------------------------------------
% classificationscript - classification using SVM
%
%---------------------------------------------------------------------------------------------
% INPUT:
%       
%
% Optional:
%
%--------------------------------------------------------------------------------------------
% OUTPUT: 
%       
%
% -------------------------------------------------------------------------------------------
% REFERENCE:
%
% Author:
%     Sudhir Shankar Raman , Dec 2015 
%

%%


% Simulate data from a mixture of gaussians
N1=60;
K = 3;
D = 2;
x1 = normrnd(1,1,N1,D);
x2 = normrnd(2.5,1,N1,D);
x3 = normrnd(4,1,N1,D);

x = [x1;x2;x3];
y = ones(K*N1,1);
y((N1+1):2*N1) = 2;
y((2*N1+1):end) = 3;

% Randomly permute data
rp = randperm(K*N1);
y = y(rp);
x = x(rp,:);
dcmlist.y = y;
dcmlist.X = x;

% Plot data if 2 D or 3 D
figure1 = figure;
subplot1 = subplot(2,1,1,'Parent',figure1);

% Create axes

if(D==3)
    view(subplot1,[-134 22]);
box(subplot1,'on');
hold(subplot1,'all');

plot3(x1(:,1),x1(:,2),x1(:,3),'b*');
plot3(x2(:,1),x2(:,2),x2(:,3),'g*');
plot3(x3(:,1),x3(:,2),x3(:,3),'r*');
else if(D==2)
        hold(subplot1,'all');
        plot(x1(:,1),x1(:,2),'b*');
        plot(x2(:,1),x2(:,2),'g*');
        plot(x3(:,1),x3(:,2),'r*');
    end
end

% Apply settings for classifier
settings = struct();
settings.kernelType = 2;
settings.crossV = 5;%-1;

output = supervised_learning_pipeline(dcmlist,settings);
subplot(2,1,2);
imagesc(output.scores,[50 100])
% Create xlabel
xlabel({'param1'},'FontWeight','bold','FontSize',24,...
    'FontName','Arial');

% Create ylabel
ylabel({'param2'},'FontWeight','bold','FontSize',24,...
    'FontName','Arial');


colorbar;
