%% --------------------------------------------------------------------------------------------------
% clusteringtest - clustering demo using kmeans and GMM
%
%---------------------------------------------------------------------------------------------
% INPUT:
%       demono - 1 - kmeans, 2- GMM
%
% Optional:
%
%--------------------------------------------------------------------------------------------
% OUTPUT: 
%       
%
% -------------------------------------------------------------------------------------------
% REFERENCE:
%
% Author:
%     Sudhir Shankar Raman , Dec 2015 
%

%%

function clusteringtest(demono)


mu = [ 1 4 7];
sigma = 1;
D = 3;
x1 = normrnd(mu(1),sigma,100,D);
x2 = normrnd(mu(2),sigma,100,D);
x3 = normrnd(mu(3),sigma,100,D);

X = [x1;x2;x3];
N = length(X);
figure1 = figure;

% Create axes
axes1 = axes('Parent',figure1);
view(axes1,[-134 22]);
box(axes1,'on');
hold(axes1,'all');

plot3(x1(:,1),x1(:,2),x1(:,3),'b*');
plot3(x2(:,1),x2(:,2),x2(:,3),'g*');
plot3(x3(:,1),x3(:,2),x3(:,3),'r*');



if(demono==1) % K means
    idxlist = [];
    cost=[];
    figure;

    % kmeans
    for i=1:7
        i
        [idx,c,sumd] = kmeans(X,i);
        cost(i) = sum(sumd);
        idxlist(i,:) = idx;    
        subplot(7,1,i);
        bar(idxlist(i,:));
        title(strcat('Cluster Assignments for K = ',num2str(i)));
    end

    figure;bar(cost)
    
else % Gaussian mixture modeling

    % number of times to run spm_mix
    n_spm_mix = 10;
    
    % test with cluster sizes 1 to 5
    figure;
    for k = 1:7
        result{k}.fm = -Inf;
        for r= 1:n_spm_mix
            tempresult = spm_mix(X,k);   
            if tempresult.fm > result{k}.fm
                result{k} = tempresult;
            end
        end

        if(k==1)
        cl_labels = ones(length(X));
        else
         [~,cl_labels] = max(result{k}.gamma);
        end
        %histc(cl_labels,1:k)

        fm(k) = result{k}.fm;
         subplot(7,1,k);
        bar(cl_labels);
        title(strcat('Cluster Assignments for K = ',num2str(k)));

    end
    figure;bar(fm(3)-fm);
end